Index: LMDZ6/branches/Amaury_dev/libf/phylmd/physiq_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/physiq_mod.F90	(revision 5098)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/physiq_mod.F90	(revision 5099)
@@ -4370,291 +4318,287 @@
 END IF
 #endif
-       !--fin STRAT AEROSOL
-       !     
-
-       ! Calculer les parametres optiques des nuages et quelques
-       ! parametres pour diagnostiques:
-       !
-       IF (aerosol_couple.AND.config_inca=='aero') THEN 
-          mass_solu_aero(:,:)    = ccm(:,:,1) 
-          mass_solu_aero_pi(:,:) = ccm(:,:,2) 
-       ENDIF
-
-       !Rajout appel a interface calcul proprietes optiques des nuages
-       CALL call_cloud_optics_prop(klon, klev, ok_newmicro, &
-               paprs, pplay, t_seri, radocond, picefra, cldfra, &
-               cldtau, cldemi, cldh, cldl, cldm, cldt, cldq, &
-               flwp, fiwp, flwc, fiwc, ok_aie, &
-               mass_solu_aero, mass_solu_aero_pi, &
-               cldtaupi, distcltop, temp_cltop, re, fl, ref_liq, ref_ice, &
-               ref_liq_pi, ref_ice_pi, scdnc, cldncl, reffclwtop, lcc, reffclws, &
-               reffclwc, cldnvi, lcc3d, lcc3dcon, lcc3dstra, icc3dcon, icc3dstra,  & 
-               zfice, dNovrN, ptconv, rnebcon, clwcon)
-
-       !
-       !IM betaCRF
-       !
-       cldtaurad   = cldtau
-       cldtaupirad = cldtaupi
-       cldemirad   = cldemi
-       cldfrarad   = cldfra
-
-       !
-       IF (lon1_beta==-180..AND.lon2_beta==180..AND. &
-           lat1_beta==90..AND.lat2_beta==-90.) THEN
-          !
-          ! global
-          !
-!IM 251017 begin
-!               print*,'physiq betaCRF global zdtime=',zdtime
-!IM 251017 end
-          DO k=1, klev
-             DO i=1, klon
-                IF (pplay(i,k)>=pfree) THEN
-                   beta(i,k) = beta_pbl
-                ELSE
-                   beta(i,k) = beta_free
-                ENDIF
-                IF (mskocean_beta) THEN
-                   beta(i,k) = beta(i,k) * pctsrf(i,is_oce)
-                ENDIF
-                cldtaurad(i,k)   = cldtau(i,k) * beta(i,k)
-                cldtaupirad(i,k) = cldtaupi(i,k) * beta(i,k)
-                cldemirad(i,k)   = cldemi(i,k) * beta(i,k)
-                cldfrarad(i,k)   = cldfra(i,k) * beta(i,k)
-             ENDDO
+      !--fin STRAT AEROSOL
+
+      ! Calculer les parametres optiques des nuages et quelques
+      ! parametres pour diagnostiques:
+
+      IF (aerosol_couple.AND.config_inca=='aero') THEN
+        mass_solu_aero(:, :) = ccm(:, :, 1)
+        mass_solu_aero_pi(:, :) = ccm(:, :, 2)
+      ENDIF
+
+      !Rajout appel a interface calcul proprietes optiques des nuages
+      CALL call_cloud_optics_prop(klon, klev, ok_newmicro, &
+              paprs, pplay, t_seri, radocond, picefra, cldfra, &
+              cldtau, cldemi, cldh, cldl, cldm, cldt, cldq, &
+              flwp, fiwp, flwc, fiwc, ok_aie, &
+              mass_solu_aero, mass_solu_aero_pi, &
+              cldtaupi, distcltop, temp_cltop, re, fl, ref_liq, ref_ice, &
+              ref_liq_pi, ref_ice_pi, scdnc, cldncl, reffclwtop, lcc, reffclws, &
+              reffclwc, cldnvi, lcc3d, lcc3dcon, lcc3dstra, icc3dcon, icc3dstra, &
+              zfice, dNovrN, ptconv, rnebcon, clwcon)
+
+      !IM betaCRF
+
+      cldtaurad = cldtau
+      cldtaupirad = cldtaupi
+      cldemirad = cldemi
+      cldfrarad = cldfra
+
+      IF (lon1_beta==-180..AND.lon2_beta==180..AND. &
+              lat1_beta==90..AND.lat2_beta==-90.) THEN
+
+        ! global
+
+        !IM 251017 begin
+        !               print*,'physiq betaCRF global zdtime=',zdtime
+        !IM 251017 end
+        DO k = 1, klev
+          DO i = 1, klon
+            IF (pplay(i, k)>=pfree) THEN
+              beta(i, k) = beta_pbl
+            ELSE
+              beta(i, k) = beta_free
+            ENDIF
+            IF (mskocean_beta) THEN
+              beta(i, k) = beta(i, k) * pctsrf(i, is_oce)
+            ENDIF
+            cldtaurad(i, k) = cldtau(i, k) * beta(i, k)
+            cldtaupirad(i, k) = cldtaupi(i, k) * beta(i, k)
+            cldemirad(i, k) = cldemi(i, k) * beta(i, k)
+            cldfrarad(i, k) = cldfra(i, k) * beta(i, k)
           ENDDO
-          !
-       ELSE
-          !
-          ! regional
-          !
-          DO k=1, klev
-             DO i=1,klon
-                !
-                IF (longitude_deg(i)>=lon1_beta.AND. &
+        ENDDO
+
+      ELSE
+
+        ! regional
+
+        DO k = 1, klev
+          DO i = 1, klon
+
+            IF (longitude_deg(i)>=lon1_beta.AND. &
                     longitude_deg(i)<=lon2_beta.AND. &
                     latitude_deg(i)<=lat1_beta.AND.  &
                     latitude_deg(i)>=lat2_beta) THEN
-                   IF (pplay(i,k)>=pfree) THEN
-                      beta(i,k) = beta_pbl
-                   ELSE
-                      beta(i,k) = beta_free
-                   ENDIF
-                   IF (mskocean_beta) THEN
-                      beta(i,k) = beta(i,k) * pctsrf(i,is_oce)
-                   ENDIF
-                   cldtaurad(i,k)   = cldtau(i,k) * beta(i,k)
-                   cldtaupirad(i,k) = cldtaupi(i,k) * beta(i,k)
-                   cldemirad(i,k)   = cldemi(i,k) * beta(i,k)
-                   cldfrarad(i,k)   = cldfra(i,k) * beta(i,k)
-                ENDIF
-             !
-             ENDDO
+              IF (pplay(i, k)>=pfree) THEN
+                beta(i, k) = beta_pbl
+              ELSE
+                beta(i, k) = beta_free
+              ENDIF
+              IF (mskocean_beta) THEN
+                beta(i, k) = beta(i, k) * pctsrf(i, is_oce)
+              ENDIF
+              cldtaurad(i, k) = cldtau(i, k) * beta(i, k)
+              cldtaupirad(i, k) = cldtaupi(i, k) * beta(i, k)
+              cldemirad(i, k) = cldemi(i, k) * beta(i, k)
+              cldfrarad(i, k) = cldfra(i, k) * beta(i, k)
+            ENDIF
+
           ENDDO
-       !
-       ENDIF
-
-       !lecture de la chlorophylle pour le nouvel albedo de Sunghye Baek 
-       IF (ok_chlorophyll) THEN
-          print*,"-- reading chlorophyll"
-          CALL readchlorophyll(debut)
-       ENDIF
-
-!--if ok_suntime_rrtm we use ancillay data for RSUN 
-!--previous values are therefore overwritten
-!--this is needed for CMIP6 runs
-!--and only possible for new radiation scheme
-       IF (iflag_rrtm==1.AND.ok_suntime_rrtm) THEN
+        ENDDO
+
+      ENDIF
+
+      !lecture de la chlorophylle pour le nouvel albedo de Sunghye Baek
+      IF (ok_chlorophyll) THEN
+        print*, "-- reading chlorophyll"
+        CALL readchlorophyll(debut)
+      ENDIF
+
+      !--if ok_suntime_rrtm we use ancillay data for RSUN
+      !--previous values are therefore overwritten
+      !--this is needed for CMIP6 runs
+      !--and only possible for new radiation scheme
+      IF (iflag_rrtm==1.AND.ok_suntime_rrtm) THEN
 #ifdef CPP_RRTM
          CALL read_rsun_rrtm(debut)
 #endif
-       ENDIF
-
-       IF (mydebug) THEN
-          CALL writefield_phy('u_seri',u_seri,nbp_lev)
-          CALL writefield_phy('v_seri',v_seri,nbp_lev)
-          CALL writefield_phy('t_seri',t_seri,nbp_lev)
-          CALL writefield_phy('q_seri',q_seri,nbp_lev)
-       ENDIF
-
-       !
-       !sonia : If Iflag_radia >=2, pertubation of some variables
-       !input to radiation (DICE)
-       !
-       IF (iflag_radia >= 2) THEN
-          zsav_tsol (:) = zxtsol(:)
-          CALL perturb_radlwsw(zxtsol,iflag_radia)
-       ENDIF
-
-       IF (aerosol_couple.AND.config_inca=='aero') THEN 
-IF (CPPKEY_INCA) THEN
+      ENDIF
+
+      IF (mydebug) THEN
+        CALL writefield_phy('u_seri', u_seri, nbp_lev)
+        CALL writefield_phy('v_seri', v_seri, nbp_lev)
+        CALL writefield_phy('t_seri', t_seri, nbp_lev)
+        CALL writefield_phy('q_seri', q_seri, nbp_lev)
+      ENDIF
+
+      !sonia : If Iflag_radia >=2, pertubation of some variables
+      !input to radiation (DICE)
+
+      IF (iflag_radia >= 2) THEN
+        zsav_tsol (:) = zxtsol(:)
+        CALL perturb_radlwsw(zxtsol, iflag_radia)
+      ENDIF
+
+      IF (aerosol_couple.AND.config_inca=='aero') THEN
+        IF (CPPKEY_INCA) THEN
           CALL radlwsw_inca  &
-               (chemistry_couple, kdlon,kflev,dist, rmu0, fract, solaire, &
-               paprs, pplay,zxtsol,albsol1, albsol2, t_seri,q_seri, &
-               size(wo,3), wo, &
-               cldfrarad, cldemirad, cldtaurad, &
-               heat,heat0,cool,cool0,albpla, &
-               topsw,toplw,solsw,sollw, &
-               sollwdown, &
-               topsw0,toplw0,solsw0,sollw0, &
-               lwdn0, lwdn, lwup0, lwup,  &
-               swdn0, swdn, swup0, swup, &
-               ok_ade, ok_aie, &
-               tau_aero, piz_aero, cg_aero, &
-               topswad_aero, solswad_aero, &
-               topswad0_aero, solswad0_aero, &
-               topsw_aero, topsw0_aero, &
-               solsw_aero, solsw0_aero, &
-               cldtaupirad, &
-               topswai_aero, solswai_aero)
-END IF
-       ELSE
-          !
-          !IM calcul radiatif pour le cas actuel
-          !
-          RCO2 = RCO2_act
-          RCH4 = RCH4_act
-          RN2O = RN2O_act
-          RCFC11 = RCFC11_act
-          RCFC12 = RCFC12_act
-          ! 
-          !--interactive CO2 in ppm from carbon cycle
-          IF (carbon_cycle_rad) RCO2=RCO2_glo
-          !
+                  (chemistry_couple, kdlon, kflev, dist, rmu0, fract, solaire, &
+                  paprs, pplay, zxtsol, albsol1, albsol2, t_seri, q_seri, &
+                  size(wo, 3), wo, &
+                  cldfrarad, cldemirad, cldtaurad, &
+                  heat, heat0, cool, cool0, albpla, &
+                  topsw, toplw, solsw, sollw, &
+                  sollwdown, &
+                  topsw0, toplw0, solsw0, sollw0, &
+                  lwdn0, lwdn, lwup0, lwup, &
+                  swdn0, swdn, swup0, swup, &
+                  ok_ade, ok_aie, &
+                  tau_aero, piz_aero, cg_aero, &
+                  topswad_aero, solswad_aero, &
+                  topswad0_aero, solswad0_aero, &
+                  topsw_aero, topsw0_aero, &
+                  solsw_aero, solsw0_aero, &
+                  cldtaupirad, &
+                  topswai_aero, solswai_aero)
+        END IF
+      ELSE
+
+        !IM calcul radiatif pour le cas actuel
+
+        RCO2 = RCO2_act
+        RCH4 = RCH4_act
+        RN2O = RN2O_act
+        RCFC11 = RCFC11_act
+        RCFC12 = RCFC12_act
+
+        !--interactive CO2 in ppm from carbon cycle
+        IF (carbon_cycle_rad) RCO2 = RCO2_glo
+
+        IF (prt_level >=10) THEN
+          print *, ' ->radlwsw, number 1 '
+        ENDIF
+
+        ! AI namelist utilise pour l appel principal de radlwsw (ecrad)
+        namelist_ecrad_file = 'namelist_ecrad'
+
+        CALL radlwsw &
+                (debut, dist, rmu0, fract, &
+                !albedo SB >>>
+                !      paprs, pplay,zxtsol,albsol1, albsol2,  &
+                paprs, pplay, zxtsol, SFRWL, albsol_dir, albsol_dif, &
+                !albedo SB <<<
+                t_seri, q_seri, wo, &
+                cldfrarad, cldemirad, cldtaurad, &
+                ok_ade.OR.flag_aerosol_strat>0, ok_aie, ok_volcan, flag_volc_surfstrat, &
+                flag_aerosol, flag_aerosol_strat, flag_aer_feedback, &
+                tau_aero, piz_aero, cg_aero, &
+                tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm, &
+                ! Rajoute par OB pour RRTM
+                tau_aero_lw_rrtm, &
+                cldtaupirad, m_allaer, &
+                !              zqsat, flwcrad, fiwcrad, &
+                zqsat, flwc, fiwc, &
+                ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
+                namelist_ecrad_file, &
+                heat, heat0, cool, cool0, albpla, &
+                heat_volc, cool_volc, &
+                topsw, toplw, solsw, solswfdiff, sollw, &
+                sollwdown, &
+                topsw0, toplw0, solsw0, sollw0, &
+                lwdnc0, lwdn0, lwdn, lwupc0, lwup0, lwup, &
+                swdnc0, swdn0, swdn, swupc0, swup0, swup, &
+                topswad_aero, solswad_aero, &
+                topswai_aero, solswai_aero, &
+                topswad0_aero, solswad0_aero, &
+                topsw_aero, topsw0_aero, &
+                solsw_aero, solsw0_aero, &
+                topswcf_aero, solswcf_aero, &
+                !-C. Kleinschmitt for LW diagnostics
+                toplwad_aero, sollwad_aero, &
+                toplwai_aero, sollwai_aero, &
+                toplwad0_aero, sollwad0_aero, &
+                !-end
+                ZLWFT0_i, ZFLDN0, ZFLUP0, &
+                ZSWFT0_i, ZFSDN0, ZFSUP0, &
+                cloud_cover_sw)
+
+        !lwoff=y, betalwoff=1. : offset LW CRE for radiation code and other
+        !schemes
+        toplw = toplw + betalwoff * (toplw0 - toplw)
+        sollw = sollw + betalwoff * (sollw0 - sollw)
+        lwdn = lwdn + betalwoff * (lwdn0 - lwdn)
+        lwup = lwup + betalwoff * (lwup0 - lwup)
+        sollwdown(:) = sollwdown(:) + betalwoff * (-1. * ZFLDN0(:, 1) - &
+                sollwdown(:))
+        cool = cool + betalwoff * (cool0 - cool)
+
+        IF (.NOT. using_xios) THEN
+
+          !IM 2eme calcul radiatif pour le cas perturbe ou au moins un
+          !IM des taux doit etre different du taux actuel
+          !IM Par defaut on a les taux perturbes egaux aux taux actuels
+
+          IF (RCO2_per/=RCO2_act.OR. &
+                  RCH4_per/=RCH4_act.OR. &
+                  RN2O_per/=RN2O_act.OR. &
+                  RCFC11_per/=RCFC11_act.OR. &
+                  RCFC12_per/=RCFC12_act) ok_4xCO2atm = .TRUE.
+        ENDIF
+
+        IF (ok_4xCO2atm) THEN
+
+          RCO2 = RCO2_per
+          RCH4 = RCH4_per
+          RN2O = RN2O_per
+          RCFC11 = RCFC11_per
+          RCFC12 = RCFC12_per
+
           IF (prt_level >=10) THEN
-             print *,' ->radlwsw, number 1 '
+            print *, ' ->radlwsw, number 2 '
           ENDIF
-          !
-          ! AI namelist utilise pour l appel principal de radlwsw (ecrad)
-          namelist_ecrad_file='namelist_ecrad'
-          !
+
+          namelist_ecrad_file = 'namelist_ecrad'
+
           CALL radlwsw &
-               (debut, dist, rmu0, fract,  &
-                                !albedo SB >>>
-                                !      paprs, pplay,zxtsol,albsol1, albsol2,  &
-               paprs, pplay,zxtsol,SFRWL,albsol_dir, albsol_dif,  &
-                                !albedo SB <<<
-               t_seri,q_seri,wo, &
-               cldfrarad, cldemirad, cldtaurad, &
-               ok_ade.OR.flag_aerosol_strat>0, ok_aie,  ok_volcan, flag_volc_surfstrat, &
-               flag_aerosol, flag_aerosol_strat, flag_aer_feedback, &
-               tau_aero, piz_aero, cg_aero, &
-               tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm, & 
-               ! Rajoute par OB pour RRTM
-               tau_aero_lw_rrtm, & 
-               cldtaupirad, m_allaer, &
-!              zqsat, flwcrad, fiwcrad, &
-               zqsat, flwc, fiwc, &
-               ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
-               namelist_ecrad_file, &
-               heat,heat0,cool,cool0,albpla, &
-               heat_volc,cool_volc, &
-               topsw,toplw,solsw,solswfdiff,sollw, &
-               sollwdown, &
-               topsw0,toplw0,solsw0,sollw0, &
-               lwdnc0, lwdn0, lwdn, lwupc0, lwup0, lwup,  &
-               swdnc0, swdn0, swdn, swupc0, swup0, swup, &
-               topswad_aero, solswad_aero, &
-               topswai_aero, solswai_aero, &
-               topswad0_aero, solswad0_aero, &
-               topsw_aero, topsw0_aero, &
-               solsw_aero, solsw0_aero, &
-               topswcf_aero, solswcf_aero, &
-                                !-C. Kleinschmitt for LW diagnostics
-               toplwad_aero, sollwad_aero,&
-               toplwai_aero, sollwai_aero, &
-               toplwad0_aero, sollwad0_aero,&
-                                !-end
-               ZLWFT0_i, ZFLDN0, ZFLUP0, &
-               ZSWFT0_i, ZFSDN0, ZFSUP0, &
-               cloud_cover_sw)
-
-          !lwoff=y, betalwoff=1. : offset LW CRE for radiation code and other
-          !schemes
-          toplw = toplw + betalwoff * (toplw0 - toplw)
-          sollw = sollw + betalwoff * (sollw0 - sollw)
-          lwdn = lwdn + betalwoff * (lwdn0 - lwdn)
-          lwup = lwup + betalwoff * (lwup0 - lwup)
-          sollwdown(:)= sollwdown(:) + betalwoff *(-1.*ZFLDN0(:,1) - &
-                        sollwdown(:))
-          cool = cool + betalwoff * (cool0 - cool)
- 
-          IF (.NOT. using_xios) THEN
-            !
-            !IM 2eme calcul radiatif pour le cas perturbe ou au moins un
-            !IM des taux doit etre different du taux actuel
-            !IM Par defaut on a les taux perturbes egaux aux taux actuels
-            !
-            IF (RCO2_per/=RCO2_act.OR. &
-                RCH4_per/=RCH4_act.OR. &
-                RN2O_per/=RN2O_act.OR. &
-                RCFC11_per/=RCFC11_act.OR. &
-                RCFC12_per/=RCFC12_act) ok_4xCO2atm =.TRUE.
-          ENDIF
-   ! 
-          IF (ok_4xCO2atm) THEN
-                !
-                RCO2 = RCO2_per
-                RCH4 = RCH4_per
-                RN2O = RN2O_per
-                RCFC11 = RCFC11_per
-                RCFC12 = RCFC12_per
-                !
-                IF (prt_level >=10) THEN
-                   print *,' ->radlwsw, number 2 '
-                ENDIF
-                !
-                namelist_ecrad_file='namelist_ecrad'
-                !
-                CALL radlwsw &
-                     (debut, dist, rmu0, fract,  &
-                                !albedo SB >>>
-                                !      paprs, pplay,zxtsol,albsol1, albsol2,  &
-                     paprs, pplay,zxtsol,SFRWL,albsol_dir, albsol_dif, & 
-                                !albedo SB <<<
-                     t_seri,q_seri,wo, &
-                     cldfrarad, cldemirad, cldtaurad, &
-                     ok_ade.OR.flag_aerosol_strat>0, ok_aie,  ok_volcan, flag_volc_surfstrat, &
-                     flag_aerosol, flag_aerosol_strat, flag_aer_feedback, &
-                     tau_aero, piz_aero, cg_aero, &
-                     tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm, &
-                                ! Rajoute par OB pour RRTM
-                     tau_aero_lw_rrtm, &
-                     cldtaupi, m_allaer, &
-!                    zqsat, flwcrad, fiwcrad, &
-                     zqsat, flwc, fiwc, &
-                     ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
-                     namelist_ecrad_file, &
-                     heatp,heat0p,coolp,cool0p,albplap, &
-                     heat_volc,cool_volc, &
-                     topswp,toplwp,solswp,solswfdiffp,sollwp, &
-                     sollwdownp, &
-                     topsw0p,toplw0p,solsw0p,sollw0p, &
-                     lwdnc0p, lwdn0p, lwdnp, lwupc0p, lwup0p, lwupp,  &
-                     swdnc0p, swdn0p, swdnp, swupc0p, swup0p, swupp, &
-                     topswad_aerop, solswad_aerop, &
-                     topswai_aerop, solswai_aerop, &
-                     topswad0_aerop, solswad0_aerop, &
-                     topsw_aerop, topsw0_aerop, &
-                     solsw_aerop, solsw0_aerop, &
-                     topswcf_aerop, solswcf_aerop, &
-                                !-C. Kleinschmitt for LW diagnostics
-                     toplwad_aerop, sollwad_aerop,&
-                     toplwai_aerop, sollwai_aerop, &
-                     toplwad0_aerop, sollwad0_aerop,&
-                                !-end
-                     ZLWFT0_i, ZFLDN0, ZFLUP0, &
-                     ZSWFT0_i, ZFSDN0, ZFSUP0, &
-                     cloud_cover_sw)
-          ENDIF !ok_4xCO2atm
-
-! A.I aout 2023
-! Effet 3D des nuages Ecrad
-! a passer : nom du ficher namelist et cles ok_3Deffect
-! a declarer comme iflag_rrtm et a lire dans physiq.def
+                  (debut, dist, rmu0, fract, &
+                  !albedo SB >>>
+                  !      paprs, pplay,zxtsol,albsol1, albsol2,  &
+                  paprs, pplay, zxtsol, SFRWL, albsol_dir, albsol_dif, &
+                  !albedo SB <<<
+                  t_seri, q_seri, wo, &
+                  cldfrarad, cldemirad, cldtaurad, &
+                  ok_ade.OR.flag_aerosol_strat>0, ok_aie, ok_volcan, flag_volc_surfstrat, &
+                  flag_aerosol, flag_aerosol_strat, flag_aer_feedback, &
+                  tau_aero, piz_aero, cg_aero, &
+                  tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm, &
+                  ! Rajoute par OB pour RRTM
+                  tau_aero_lw_rrtm, &
+                  cldtaupi, m_allaer, &
+                  !                    zqsat, flwcrad, fiwcrad, &
+                  zqsat, flwc, fiwc, &
+                  ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
+                  namelist_ecrad_file, &
+                  heatp, heat0p, coolp, cool0p, albplap, &
+                  heat_volc, cool_volc, &
+                  topswp, toplwp, solswp, solswfdiffp, sollwp, &
+                  sollwdownp, &
+                  topsw0p, toplw0p, solsw0p, sollw0p, &
+                  lwdnc0p, lwdn0p, lwdnp, lwupc0p, lwup0p, lwupp, &
+                  swdnc0p, swdn0p, swdnp, swupc0p, swup0p, swupp, &
+                  topswad_aerop, solswad_aerop, &
+                  topswai_aerop, solswai_aerop, &
+                  topswad0_aerop, solswad0_aerop, &
+                  topsw_aerop, topsw0_aerop, &
+                  solsw_aerop, solsw0_aerop, &
+                  topswcf_aerop, solswcf_aerop, &
+                  !-C. Kleinschmitt for LW diagnostics
+                  toplwad_aerop, sollwad_aerop, &
+                  toplwai_aerop, sollwai_aerop, &
+                  toplwad0_aerop, sollwad0_aerop, &
+                  !-end
+                  ZLWFT0_i, ZFLDN0, ZFLUP0, &
+                  ZSWFT0_i, ZFSDN0, ZFSUP0, &
+                  cloud_cover_sw)
+        ENDIF !ok_4xCO2atm
+
+        ! A.I aout 2023
+        ! Effet 3D des nuages Ecrad
+        ! a passer : nom du ficher namelist et cles ok_3Deffect
+        ! a declarer comme iflag_rrtm et a lire dans physiq.def
 #ifdef CPP_ECRAD
           IF (ok_3Deffect) then
-!                print*,'ok_3Deffect = ',ok_3Deffect  
+!                print*,'ok_3Deffect = ',ok_3Deffect
                 namelist_ecrad_file='namelist_ecrad_s2'
                 CALL radlwsw &
@@ -4672,5 +4616,5 @@
                      ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
                      namelist_ecrad_file, &
-! A modifier              
+! A modifier
                      heat_s2,heat0_s2,cool_s2,cool0_s2,albpla_s2, &
                      heat_volc,cool_volc, &
